	list	p=16F628
	#include p16F628.inc
; CONFIGURATION XTAL ET WATCHDOG SUR OFF
	__CONFIG  _XT_OSC&_WDT_OFF&_LVP_OFF
BOOLEEN	EQU	H'0020'
ADD_I2C	EQU	H'0021'
ADD_HAUT	EQU	H'0022'
ADD_BAS	EQU	H'0023'
OCTET	EQU	H'0024'
VALEUR	EQU	H'0025'
I	EQU	H'0026'
VBFOR1	EQU	H'0027'
;(1) DFINITION DES ETIQUETTES ET VARIABLES
SCL	EQU	3
SDA	EQU 	4
I2CACK	EQU	0
	ORG       0
;(2) INITIALISATION
INIT	MOVLW	H'07'
	MOVWF	CMCON
	BSF STATUS, RP0
	MOVLW	H'02'
	MOVWF	TRISA
	MOVLW	H'00'
	MOVWF	TRISB
	MOVLW	H'7F'
	MOVWF	PR2
	BCF STATUS, RP0
	MOVLW	H'04'
	MOVWF	T2CON
	MOVLW	H'0C'
	MOVWF	CCP1CON
	BCF PORTB,0  
	BSF       PORTA,SCL  
	BSF       PORTA,SDA 
	CLRF      BOOLEEN   
;(3) ATTENTE D'APPUI SUR LE BP
PRIN	BTFSC PORTA,1
	GOTO	PRIN
;(4) ACCS  L'EEPROM
	MOVLW	H'00'
	MOVWF	ADD_HAUT
	MOVLW	H'00'
	MOVWF	ADD_BAS
	MOVLW	H'A0'
	MOVWF	ADD_I2C
	CALL	ADRESSAGE
;(5) ENVOI DE L'ORDRE DE LECTURE
	CALL	START
	MOVF	ADD_I2C,0
	ADDLW	H'01'
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
;(6) RECEPTION DES 32768 OCTETS
BOUC	CALL	LIS_OCTET
	CALL	SETACK
	BTFSC OCTET,0
	BSF CCP1CON,5
	BTFSS OCTET,0
	BCF CCP1CON,5
	RRF OCTET,1
	MOVF	OCTET,0
	MOVWF	CCPR1L
	INCF ADD_BAS,1
	BTFSC STATUS,Z
	INCF ADD_HAUT,1
	BTFSC ADD_HAUT,7
	GOTO	PRIN
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO	BOUC
	GOTO	FIN
;(7) DIVERS SOUS-PROGRAMMES I2C
ECRI_EEP	CALL	ADRESSAGE
	MOVF	VALEUR,0
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
	CALL	STOP
	RETURN
ADRESSAGE	CALL	START
	MOVF	ADD_I2C,0
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
	MOVF	ADD_HAUT,0
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
	MOVF	ADD_BAS,0
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
	RETURN
LIRE_EEP	CALL	ADRESSAGE
	CALL	START
	MOVF	ADD_I2C,0
	ADDLW	H'01'
	MOVWF	OCTET
	CALL	ENV_OCTET
	CALL	GETACK
	CALL	LIS_OCTET
	CALL	NOACK
	CALL	STOP
	RETURN
START      BSF       PORTA,SCL  ; AU DEBUT, SCL
	BSF       PORTA,SDA  ; ET SDA SONT A '1'.
	CALL	TEMPO5US
	BCF       PORTA,SDA 
	CALL	TEMPO5US
 	BCF       PORTA,SCL
	CALL	TEMPO5US
	BSF       PORTA,SDA
	RETURN
STOP	BCF       PORTA,SCL  ; AU DEBUT, SCL
	BCF       PORTA,SDA  ; ET SDA SONT A '0'.
	CALL	TEMPO5US
	BSF       PORTA,SCL 
	CALL	TEMPO5US
	BSF       PORTA,SDA
	CALL	TEMPO5US
	RETURN
ENV_OCTET	MOVLW	H'01'
	MOVWF	I
	SUBLW	H'08'
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	BCF       PORTA,SCL  
	BTFSS     OCTET,7     
	BCF       PORTA,SDA     
	BTFSC     OCTET,7  
	BSF       PORTA,SDA 
	CALL	TEMPO5US
	BSF       PORTA,SCL  
	CALL	TEMPO5US
	BCF       PORTA,SCL      ;
	RLF       OCTET,1    
	INCF	I,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
 	BSF       PORTA,SDA    
	RETURN
LIS_OCTET     CLRF      OCTET     
	MOVLW	H'08'
	MOVWF	I
	BCF       PORTA,SCL     ;- SCL MIS A '0'.
SP_B	BSF       PORTA,SDA     ;- SDA MIS A '1'
	NOP
	BSF       PORTA,SCL     ;- SCL PASSE A '1'.
	RLF       OCTET,1     
	BCF       OCTET,0   
	NOP
	CALL	TEMPO5
	BTFSC     PORTA,SDA   
	BSF       OCTET,0  
	BCF       PORTA,SCL     ;- SCL MIS A '0'.
	DECFSZ	I,1
	GOTO	SP_B
	BCF       PORTA,SCL    
	RETURN
GETACK	BSF       PORTA,SDA     
	BCF       PORTA,SCL      
	CALL	TEMPO5US
	BSF       PORTA,SCL    
	CALL	TEMPO5US
	BCF       BOOLEEN,I2CACK  
	BTFSS     PORTA,SDA   
	BSF       BOOLEEN,I2CACK 
	BCF       PORTA,SCL  
	RETURN
SETACK	BCF       PORTA,SDA 
	BSF       PORTA,SCL 
	CALL	TEMPO5US
	BCF       PORTA,SCL 
	NOP
	BSF       PORTA,SDA
	RETURN
NOACK	BCF       PORTA,SCL 
	BSF       PORTA,SDA 
	CALL	TEMPO5US
	BSF       PORTA,SCL
	CALL	TEMPO5US
	BCF       PORTA,SCL
	RETURN
;(8)TEMPORISATIONS DIVERSES
TEMPO5US	CALL	TEMPO7
TEMPO5	NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
	RETURN
TEMPO7	NOP
		NOP
		NOP
	RETURN
	NOP	  
FIN	NOP
	BSF PORTB,0
	NOP
	END
